<?php

class eranet_HTTPClient{

    /*@var GuzzleHttp **/
    private  $client;
    public $serverURL;
    public $VCP;
    public $VCPPassword;


    function sign( $params){
//        $params['auth']=$this->VCP;
//        $params['api-key']=$this->VCPPassword;
        return $params;
    }

    public function request($action,$params=[],$method="POST"){
        $query = $this->sign($params);
        $url="http://{$this->serverURL}{$action}?auth-userid={$this->VCP}&api-key={$this->VCPPassword}";
        if($method=="GET"){
            $url.="&".http_build_query($query);
        }else{
            $content=[];
            foreach ($query as $key=> $value){
                if(is_array($value)){
                    foreach ($value as $v){
                        $content[]="{$key}={$v}";
                    }
                }else{
                    $content[]="{$key}={$value}";
                }
            }
            $content=implode("&",$content);
        }
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            "Content-Type: application/x-www-form-urlencoded"
        ));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        if ($method == "POST") {
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
        }
        $response = curl_exec($ch);
        curl_close($ch);
        $json= json_decode($response,1);
        return $json?$json:$response;
    }
}

class eranet_Domain extends eranet_HTTPClient{
	public $domaintype;


	public function __construct($params)
	{
		//ini_set("error_reporting",E_ALL ^ E_NOTICE);
		$this->serverURL = $params['confServer'];
		$this->VCP = $params['confUserID'];
		$this->VCPPassword = $params['confAPIPassword'];
		$this->domainSuffix = array(
						'net' => 'dotcom',
						'cm' => 'dotcmcom',
						'vc' => 'dotrrp',
						'la' => 'dotrrp',
						'ac' => 'dotsh',
						'中国' => 'dotch',
						'网络' => 'dotch',
						'公司' => 'dotch',
						'中國' => 'dotch',
						'網絡' => 'dotch',
						'公司' => 'dotch',
						'cm' => 'dotcmcom',
						'xn-iqs8s' => 'dotch',
						'xn-o0a7i' => 'dotch',
						'xn-5qx5d' => 'dotch',
						'xn-6w193g' => 'dothk',
						'asia' => 'dotasia',
						'de' => 'dotrrp',
						'jp' => 'dotrrp',
						'kr' => 'dotrrp',
						'uk' => 'dotrrp',
						'uscom' => 'dotrrp',
						'ukcom' => 'dotrrp',
						'it' => 'dotrrp',
						'website' => 'dotpw',
						'fr' => 'dotrrp',
						);
	}


    /**
     * [createContact create a new contact]
     */
    public function createContact($contactI){
        $action="/api/contacts/add.json";
        $resp=$this->request($action,$contactI);
        if(is_array($resp)){
            return json_encode($resp,1);
        }
        return $resp;
    }

    /**
     * [createDomain create a new domain]
     * @param  [array] $domainI include $domainI['domainname'] and $domainI['domainperiod']
     * @param  [array] $Regist the registrant's contact infomation array of the domain
     * @param  [array] $Admin	the admin's contact infomation array of the domain
     * @param  [array] $Tech 	the tech's contact infomation array of the domain
     * @param  [array] $Billing 	the billing's contact infomation array of the domain
     * @return [xml]
     */
    public function createDomain($domainName,$years,$ns ,$reg_contact_id,$admin_contact_id)
    {
        $action="/api/domains/register.xml";
        $p = [
            'domain-name' => $domainName,
            'years' => $years,
            'reg-contact-id' => $reg_contact_id,
            'admin-contact-id' => $admin_contact_id,
            'ns' => implode(";",$ns),
        ];
        $resp=$this->request($action,$p);
        if($resp['actionstatus']=='Success'){
            return true;
        }
        return $resp['actionstatusdesc'];
    }

    public function orderid($domainName){
        $action="/api/domains/orderid.json";
        $p=[
            'domain-name'=>$domainName
        ];
        $resp=$this->request($action,$p,"GET");
        if(is_array($resp)){
            return json_encode($resp,1);
        }
        return $resp;
    }


    /**
     * [renewDomain renew a domain is appointed]
     * @param  [array] $domainI 	include $domainI['domainname'] and $domainI['curexpired'] and $domainI['domainperiod']
     * @return [xml]
     */
    public function renewDomain($domainI){
        $action="/api/domains/renew.json";
        $p=[
            'order-id'=>$domainI['domain_id'],
            'years'=>$domainI['domainperiod'],
            'exp-date'=>strtotime($domainI['curexpired']),
        ];
        $resp=$this->request($action,$p);
        if(isset($resp['status'])&&$resp['status']=='ERROR'){
            return $resp['message'];
        }
        return true;
    }

    /**
     * [infoDomain check the infomation of the domain is appointed]
     * @param  [string] $domain
     * @return [xml]
     */
    public function infoDomain($domain_id )
    {
        $action="/api/domains/details.json";
        $p = [
            'order-id' => $domain_id,
            'options' => 'All',
        ];
        $resp=$this->request($action,$p,"GET");
        return $resp;
    }

    public function modifyNs($domain_id,$ns){
        $action="/api/domains/modify-ns.json";
        $p=[
            'order-id' => $domain_id,
            'ns'=>$ns,
        ];
        $resp=$this->request($action,$p);
        if($resp['actionstatus']=='Success'){
            return true;
        }
        return $resp['actionstatusdesc'];
    }

    /**
     * [transferDomain description]
     * @param  [array] $domainI
     * @param  [array] $Regist
     * @param  [array] $Admin
     * @param  [array] $Tech
     * @param  [array] $Billing
     * @return [xml]
     */
    public function transferDomain($domainName,$authCode ,$reg_contact_id,$admin_contact_id )
    {
        $action="/api/domains/transfer.json";
        $p = [
            'domain-name' => $domainName,
            'auth-code' => $authCode,
            'reg-contact-id' => $reg_contact_id,
            'admin-contact-id' => $admin_contact_id,
            'tech-contact-id' => $admin_contact_id,
            'billing-contact-id' => $admin_contact_id,
        ];
        $resp=$this->request($action,$p);
        if($resp['actionstatus']=='Success'){
            return true;
        }
        return $resp['actionstatusdesc'];
    }
    
    public function describeRecordIndex($domainName){
        $action="/api/dns/describe-record-index.json";
        $p = [
            "Domain"=>$domainName,
            "pageSize"=>500
            ];
         $resp=$this->request($action,$p);
        return $resp;
    }
     public function AddDomainRecord($domainName,$Host,$Type,$Value,$Mx){
        $action="/api/dns/add-domain-record.json";
        $p = [
            "Domain"=>$domainName,
            "Host"=>$Host,
            'Type'=>$Type,
            'Value'=>$Value,
            'Mx'=>$Mx,
            'Ttl'=>600,
            ];
         $resp=$this->request($action,$p,"GET");
        return $resp;
    }
     public function UpdateDomainRecord($Id,$Host,$Type,$Value,$Mx){
        $action="/api/dns/update-domain-record.json";
        $p = [
            "Id"=>$Id,
            "Host"=>$Host,
            'Type'=>$Type,
            'Value'=>$Value,
            'Mx'=>$Mx,
            'Ttl'=>600,
            ];
         $resp=$this->request($action,$p,"GET");
        return $resp;
    }
    public function DeleteDomainRecord($Id){
        $action="/api/dns/delete-domain-record.json";
        $p = [
            "Id"=>$Id,
            ];
         $resp=$this->request($action,$p,"GET");
        return $resp;
    }
}

